"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default() {
  return function ({
    addUtilities,
    e,
    config
  }) {
    const generators = [(size, modifier) => ({
      [`.${e(`inset-${modifier}`)}`]: {
        top: `${size}`,
        right: `${size}`,
        bottom: `${size}`,
        left: `${size}`
      }
    }), (size, modifier) => ({
      [`.${e(`inset-y-${modifier}`)}`]: {
        top: `${size}`,
        bottom: `${size}`
      },
      [`.${e(`inset-x-${modifier}`)}`]: {
        right: `${size}`,
        left: `${size}`
      }
    }), (size, modifier) => ({
      [`.${e(`top-${modifier}`)}`]: {
        top: `${size}`
      },
      [`.${e(`right-${modifier}`)}`]: {
        right: `${size}`
      },
      [`.${e(`bottom-${modifier}`)}`]: {
        bottom: `${size}`
      },
      [`.${e(`left-${modifier}`)}`]: {
        left: `${size}`
      }
    })];

    const utilities = _lodash.default.flatMap(generators, generator => {
      return _lodash.default.flatMap(config('theme.inset'), generator);
    });

    addUtilities(utilities, config('variants.inset'));
  };
}