"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default() {
  return function ({
    addUtilities,
    e,
    config
  }) {
    const generators = [(size, modifier) => ({
      [`.${e(`m-${modifier}`)}`]: {
        margin: `${size}`
      }
    }), (size, modifier) => ({
      [`.${e(`my-${modifier}`)}`]: {
        'margin-top': `${size}`,
        'margin-bottom': `${size}`
      },
      [`.${e(`mx-${modifier}`)}`]: {
        'margin-left': `${size}`,
        'margin-right': `${size}`
      }
    }), (size, modifier) => ({
      [`.${e(`mt-${modifier}`)}`]: {
        'margin-top': `${size}`
      },
      [`.${e(`mr-${modifier}`)}`]: {
        'margin-right': `${size}`
      },
      [`.${e(`mb-${modifier}`)}`]: {
        'margin-bottom': `${size}`
      },
      [`.${e(`ml-${modifier}`)}`]: {
        'margin-left': `${size}`
      }
    })];

    const utilities = _lodash.default.flatMap(generators, generator => {
      return _lodash.default.flatMap(config('theme.margin'), generator);
    });

    addUtilities(utilities, config('variants.margin'));
  };
}